import numpy as np
from scipy import signal as s
import pandas as pd
from scipy.optimize import leastsq
import matplotlib.pyplot as plt

class SignalElectrical:
    """SignalElectrical class contains static methods for calculation of resistance from voltage and current dbsignal"""
    
    @staticmethod
    def calculateResistances(dataFrame, uNames, iNames, rNames):
        """Method calculates and appends resistance values to passed DataFrame based on the passed uNames and iNames"""
        for uName, iName, rName in zip(uNames, iNames, rNames):
            dataFrame[rName] = dataFrame[uName] / dataFrame[iName]
        
    @staticmethod
    def filterResistancesForCurrentBelowThreshold(dataFrame, iNames, rNames, currentThresholdInAmps=1):
        """Method filters alle resistance values for current values below a certain value"""
        for iName, rName in zip(iNames, rNames):
            select_indices = list(np.where(abs(dataFrame[iName]) <= currentThresholdInAmps)[0])
            dataFrame[rName].iloc[select_indices] = 0  
    
 